enum Category {
  Biography,     // 0
  Poetry,        // 1
  Fiction,       // 2
}

function GetAllBooks() {
  let books = [
    {
      author: 'James Joyce',
      available: true,
      category: Category.Fiction,
      id: 1,
      title: 'Ulysses',
    },
    {
      author: 'Ernest Hemingway',
      available: false,
      category: Category.Fiction,
      id: 2,
      title: 'A farewall to arms',
    },
    {
      author: 'Maya Angelou',
      available: true,
      category: Category.Poetry,
      id: 3,
      title: 'I know why the caged bird sings',
    },
    {
      author: 'Herman Melville',
      available: true,
      category: Category.Fiction,
      id: 4,
      title: 'Moby Dick',
    }
  ];

  return books;
}

function LogFirstAvailable(books): void {

  const numberOfBooks: number = books.length;
  let firstAvailable: string = '';
  for (let currentBook of books) {
    if (currentBook.available) {
      firstAvailable = currentBook.title;
      break;
    }
  }

  console.log(`Total number of books: ${numberOfBooks}.`);
  console.log(`First available: ${firstAvailable}.`);
}

function GetBookTitlesByCategory(categoryFilter: Category): Array<string> {
  console.log(`Getting books in category: ${Category[categoryFilter]}.`);

  const allBooks = GetAllBooks();
  const filteredTitles: string[] = [];

  for (let currentBook of allBooks) {
    if (currentBook.category === categoryFilter) {
      filteredTitles.push(currentBook.title);
    }
  }
  return filteredTitles;
}

function GetBookById(id: number) {
  const allBooks = GetAllBooks();
  return allBooks.filter(book => book.id === id)[0];
}

function LogBookTitles(titles: string[]): void {
  for (let title of titles) {
    console.log(title);
  }
}

//******************************************************************************

const fictionBookTitles = GetBookTitlesByCategory(Category.Fiction);
// LogBookTitles(fictionBookTitles);
fictionBookTitles.forEach((val, idx, arr) => console.log(`${++idx} ${val}.`));

console.log(GetBookById(2));

function PublicationMessage(year: number): string {
  return year.toLocaleString();
}

type publisherFunc = (y: number) => string;
let publishFunc: publisherFunc = PublicationMessage;

